<template>
  <div>
    <v-dialog 
      v-model="visible" 
      persistent 
      max-width="500px">
      <v-card>
        <v-card-title class="headline error-text">{{ $t('filemanager.createFolder.title') }}</v-card-title>
      
        <v-card-text>
          <v-form 
            ref="form" 
            v-model="valid" 
            lazy-validation>
            <v-text-field
              v-model="data.name"
              :label="$t('filemanager.createFolder.nameInputLabel')"
              :rules="rules.nameRules"
              required
            />
          </v-form>
        </v-card-text>

        <v-card-actions>
          <v-spacer/>
          <v-btn 
            flat 
            @click.native="close">Cancel</v-btn>
          <v-btn 
            :disabled="!valid" 
            color="primary" 
            flat 
            @click.native="submit">Create</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import {bus} from '@js/bus'

export default {
	/*props: [

	],*/

	data() {
		return {
			valid: true,
			visible: false,
			data: {
				name: null
			},
			rules: {
				nameRules: [
					v => !!v || this.$t('filemanager.createFolder.nameErrorLabel')
				],
			}
		}
	},

	created() {
		bus.$on('create-folder', this.show)
	},

	beforeDestroy() {
		bus.$off('create-folder', this.show)
	},

	methods: {
		show() {
			this.valid = true
			this.data.name = this.$t('filemanager.createFolder.defaultName')
			this.visible = true
		},

		submit() {
			if( this.$refs.form.validate() ) {
				this.$emit('submit', this.data)
				this.close()
			}
		},

		close() {
			this.visible = false
		}
	},


}
</script>